# -*- coding: utf-8 -*-
"""
Created on Sat Feb 13 11:55:47 2016

@author: https://www.codefellows.org/blog/implementing-a-singly-linked-list-in-python
@author: http://www.science.smith.edu/dftwiki/index.php/CSC212_Linked_List_in_Python
"""

class Node(object):

    def __init__(self, data=None, next_node=None):
        self.data = data
        self.next_node = next_node

    def get_data(self):
        return self.data

    def get_next(self):
        return self.next_node

    def set_next(self, new_next):
        self.next_node = new_next


class LinkedList(object):

    def __init__(self, head=None):
        self.head = self.tail = head

    """
    def insert_beginning(self, data):
        new_node = ListNode(data, self.head)
        self.head = new_node

    def insert(self, data):
        new_node = Node(data)
        new_node.set_next(self.head)
        self.head = new_node
    """ 
    
    def add_front(self, data):
        new_node = Node(data)
        new_node.set_next(self.head)
        if self.head == None:
            self.tail = self.head = new_node
        else:
            self.head = new_node

    def add_tail(self, data):
        if self.head == None:
            self.add_front(data)
        else:
            new_node = Node(data)
            new_node.set_next(None)            
            self.tail.set_next(new_node)
            self.tail = self.tail.get_next()        

    def size(self):
        current = self.head
        count = 0
        while current:
            count += 1
            current = current.get_next()
        return count

    def search(self, data):
        current = self.head
        found = False
        while current and found is False:
            if current.get_data() == data:
                found = True
            else:
                current = current.get_next()
        if current is None:
            raise ValueError("Data not in list")
        return current

    """
    def delete(self, data):
        current = self.head
        previous = None
        found = False
        while current and found is False:
            if current.get_data() == data:
                found = True
            else:
                previous = current
                current = current.get_next()
        if current is None:
            raise ValueError("Data not in list")
        if previous is None:
            self.head = current.get_next()
        else:
            previous.set_next(current.get_next())
    """