# -*- coding: utf-8 -*-
"""
Created on Sat Feb 13 11:58:52 2016

@author: Han-Wei
"""

from mpl_toolkits.mplot3d import Axes3D
from matplotlib import cm
from matplotlib.colors import LightSource
import matplotlib.pyplot as plt
from matplotlib.collections import PolyCollection
from matplotlib.colors import colorConverter

import csv
from linkedlist import Node, LinkedList
import numpy as np

(TITLE, YEAR, MONTH, CALLNUMBER) = range(4)
gBookList = ["republic", \
             "leviathan", \
             "prince", \
             "clashOfCivilizations", \
             "elementsOfStyle", \
             "ethics", \
             "structureOfScientificRevolutions", \
             "democracyInAmerica", \
             "communistManifesto", \
             "politics"]

gStartYear, gEndYear = 2006, 2014
gStartMonth, gEndMonth = 1, 52
gZ = []


def cc(arg):
    return colorConverter.to_rgba(arg, alpha=0.6)


def load_csv(fileName, ls):
    with open(fileName, 'rb') as inFile:
        hasHeader = csv.Sniffer().has_header(inFile.read(1024))
        inFile.seek(0)  # rewind
        inCSV = csv.reader(inFile)
        if hasHeader:
            next(inCSV)  # skip header row
        # data = [[row[0], eval(row[1]), eval(row[2]), row[3]] for row in inCSV]
        ls = LinkedList()
        for row in inCSV:
            ls.add_tail([row[TITLE], 
                                 eval(row[YEAR]), 
                                 eval(row[MONTH]), 
                                 row[CALLNUMBER]])
                # zCount += 1
            # curYear, curMonth = eval(row[YEAR]), eval(row[MONTH])
        
        # print republicList.head.get_next().get_data()

    _z = [0]
    entry = ls.head
    if entry != None:
        for curYear in range(gStartYear, gEndYear + 1):
            curMonth = gStartMonth
            while curMonth <= gEndMonth:
                if entry != None:
                    if curYear == entry.get_data()[YEAR] and \
                        curMonth == entry.get_data()[MONTH]:
                        _z[len(_z)-1] += 1
                        entry = entry.get_next()
                        curMonth -= 1
                    else:
                        _z.append(0)
                else:
                    _z.append(0)
                curMonth += 1
    del _z[-1]
    print zip(*[iter(_z)]*52)
    print "\n\n"
    
    return _z
    """
    nrows, ncols = 1, len(z)
    x = np.linspace(0, ncols, ncols)
    y = np.linspace(0, 0, nrows)
    x, y = np.meshgrid(x, y)

    region = np.s_[0:1, 5:50]
    x, y, z = x[region], y[region], z[region]
    
    fig, ax = plt.subplots(subplot_kw=dict(projection='3d'))
    
    ls = LightSource(270, 45)
    # To use a custom hillshading mode, override the built-in shading and pass
    # in the rgb colors of the shaded surface calculated from "shade".
    # rgb = ls.shade(z, cmap=cm.gist_earth, norm=None, blend_mode='soft', vert_exag=0.1)
    rgb = ls.shade(z, cmap=cm.gist_earth, norm=None, blend_mode='soft', vert_exag=0.1)
    surf = ax.plot_surface(x, y, z, rstride=1, cstride=1, facecolors=rgb,
                           linewidth=0, antialiased=False, shade=False)       
    """
          
                 
if __name__ == '__main__':
    bookList = LinkedList()
    for book in gBookList:
        bookList.add_tail(book)
        gZ.append( load_csv(book + '.csv', bookList.search(book)) )

    
    zs = np.array(gZ)
    nrows, ncols = zs.shape
    
    xs = np.linspace(1, ncols, ncols)
    xs = np.insert(xs, 0, 0)
    xs = np.append(xs, [ncols + 1])
    
    ys = np.linspace(1, nrows, nrows)
    # zs = zs.ravel()
    verts = []
    for idx, val in enumerate(ys):
        newZs = np.insert(zs[idx, :], 0, 0)
        newZs = np.append(newZs, [0])
        verts.append(list(zip(xs, newZs)))
    """
    fig = plt.figure()
    fig.set_size_inches(18.5, 10.5, forward=True)
    ax = fig.gca(projection='3d')    
    
    poly = PolyCollection(verts, facecolors=[cc('r'), cc('g'), cc('b'), cc('y'), cc('r'), cc('g'), cc('b'), cc('y'), cc('r'), cc('g')])
    
    poly.set_alpha(0.7)
    ax.add_collection3d(poly, zs=ys, zdir='y')
    
    ax.set_xlabel('MONTH')
    ax.set_xlim3d(-10, ncols)
    
    # ax.set_ylabel('BOOKS TITLE')
    ax.set_ylim3d(1, 10)
    ax.w_yaxis.set_ticklabels(gBookList)
    
    ax.set_zlabel('CHECKOUT #')
    ax.set_zlim3d(0, 8)
    
    plt.show()    
    """
    
    z = np.array(gZ)
    nrows, ncols = z.shape
    x = np.linspace(0, ncols - 1, ncols)
    y = np.linspace(0, nrows - 1, nrows)
    x, y = np.meshgrid(x, y)
    
    region = np.s_[0:ncols, 0:ncols]
    x, y, z = x[region], y[region], z[region]
    
    fig, ax = plt.subplots(subplot_kw=dict(projection='3d'))
    fig.set_size_inches(18.5, 10.5, forward=True)
    
    ls = LightSource(270, 45)
    ax.w_yaxis.set_ticklabels(gBookList)
    # To use a custom hillshading mode, override the built-in shading and pass
    # in the rgb colors of the shaded surface calculated from "shade".
    rgb = ls.shade(z, cmap=cm.gist_earth, norm=None, blend_mode='soft', vert_exag=0.1)
    surf = ax.plot_surface(x, y, z, rstride=1, cstride=1, facecolors=rgb, linewidth=0, cmap=cm.coolwarm, \
                            antialiased=False, shade=False)    
    plt.show()
